import java.io.*;
import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;
import org.antlr.stringtemplate.*;


public class Test {
	public static void main(String[] args) throws Exception {
/* tpl */
		FileReader groupFile = new FileReader("pierwszy.stg");
		StringTemplateGroup templates = new StringTemplateGroup(groupFile);
		groupFile.close();
/* /tpl */

		// Tworzymy analizator leksykalny i kaemy mu czyta z stdin
		ANTLRInputStream input = new ANTLRInputStream(System.in);
		ExprLexer lexer = new ExprLexer(input);

		// Tworzymy bufor na tokeny pomiedzy analizatorem leksykalnym a parserem
		CommonTokenStream tokens = new CommonTokenStream(lexer);

		// Tworzymy parser czytajcy z powyszego bufora
		ExprParser parser = new ExprParser(tokens);	/* wersja "normalna" */
//		ExprParser parser = new ExprParser(tokens, 49100, null); /* wersja do debugowania */


		try {
			// Wywoujemy parser generujcy drzewo startujc od reguy prog (Z klasy Expr)
			ExprParser.prog_return root = parser.prog();

			// Tworzymy bufor na wzy drzewa
			CommonTreeNodeStream nodes = new CommonTreeNodeStream(root.tree);
			System.out.println(((CommonTree)root.tree).toStringTree());

			// Tworzymy parser drzew korzystajcy z powyszego bufora
			TTExpr trans = new TTExpr(nodes);	/* wersja "normalna" */
//	  	TTExpr trans = new TTExpr(nodes, 49100, null); /* wersja do debugowania */

			// parsujemy drzewo - wynik do troot
			TTExpr.prog_return troot = trans.prog();

			// Tworzymy bufor na wzy drzewa
			CommonTreeNodeStream tnodes = new CommonTreeNodeStream(troot.tree);
			
			// Tworzymy parser drzew korzystajcy z powyszego bufora
			TExpr walker = new TExpr(tnodes);	/* wersja "normalna" */
//		  TExpr walker = new TExpr(nodes, 49100, null); /* wersja do debugowania */

/* tpl */
			// Tumaczymy parserowi drzew, jakich szablonw ma uywa
			walker.setTemplateLib(templates);

			// Wywoujemy parser drzew - startujc od reguy prog (Tym razem z klasy TExpr!)
			TExpr.prog_return tpl = walker.prog();

			// Pobierz "wypeniony" szablon
			StringTemplate stp = (StringTemplate) tpl.getTemplate();
/* /tpl */

			// Wypisujemy drzewo na standardowe wyjcie
			System.out.println(((CommonTree)troot.tree).toStringTree());

/* tpl */
			// Wypisujemy wypeniony szablon
			System.out.println(stp.toString());
/* /tpl */

		} catch (RecognitionException e) {
				e.printStackTrace();
		}

	}
}
